Loading...
Searching...
No Matches
VolumeToMesh.h File Reference

Extract polygonal surfaces from scalar volumes. More...

`#include <openvdb/Platform.h>`
`#include <openvdb/math/Operators.h>`
`#include <openvdb/tree/ValueAccessor.h>`
`#include <openvdb/util/Util.h>`
`#include <openvdb/openvdb.h>`
`#include <tbb/blocked_range.h>`
`#include <tbb/parallel_for.h>`
`#include <tbb/parallel_reduce.h>`
`#include <tbb/task_arena.h>`
`#include <cmath>`
`#include <cstring>`
`#include <map>`
`#include <memory>`
`#include <set>`
`#include <type_traits>`
`#include <vector>`

Go to the source code of this file.

## Classes

class | PolygonPool
| Collection of quads and triangles. More...
struct | VolumeToMesh
| Mesh any scalar grid that has a continuous isosurface. More...

## Namespaces

namespace | openvdb
namespace | openvdb::v11_0
namespace | openvdb::v11_0::tools

## Typedefs

using | PointList = std::unique_ptr<openvdb::Vec3s[]>
| Point and primitive list types.
using | PolygonPoolList = std::unique_ptr<PolygonPool[]>
| Point and primitive list types.

## Enumerations

enum | { POLYFLAG_EXTERIOR = 0x1 , POLYFLAG_FRACTURE_SEAM = 0x2 , POLYFLAG_SUBDIVIDED = 0x4 }
| Polygon flags, used for reference based meshing. More...

## Functions

template<typename GridType>
void | volumeToMesh (const GridType &grid, std::vector< Vec3s > &points, std::vector< Vec4I > &quads, double isovalue=0.0)
| Uniformly mesh any scalar grid that has a continuous isosurface.
template<typename GridType>
void | volumeToMesh (const GridType &grid, std::vector< Vec3s > &points, std::vector< Vec3I > &triangles, std::vector< Vec4I > &quads, double isovalue=0.0, double adaptivity=0.0, bool relaxDisorientedTriangles=true)
| Adaptively mesh any scalar grid that has a continuous isosurface.
Vec3d | findFeaturePoint (const std::vector< Vec3d > &points, const std::vector< Vec3d > &normals)
| Given a set of tangent elements, `points` with corresponding `normals`, this method returns the intersection point of all tangent elements.

## Detailed Description

Extract polygonal surfaces from scalar volumes.

Author
  Mihai Alden